isType     = require("./isType")
byteLength = require("./byteLength")
{ goTo }   = require("../hijackBrowser/index") if process.browser
statuses   = 
	empty:
		204: true
		205: true
		304: true
	redirect:
		300: true
		301: true
		302: true
		303: true
		305: true
		307: true
		308: true

###
# A default middleware that handles sending the response for the request.
#
# @param {Object} req
# @param {Object} res
# @param {Function} next
###
module.exports = (req, res, next)->
	yield next
	{ method, redirectURL } = req
	{ originalRes, headers, status, body } = res

	# Skip request if something had already ended it.
	return if originalRes.headersSent

	# Handle redirects from the request object.
	if redirectURL?
		if process.browser
			if redirectURL?
				goTo(redirectURL,
					replaceState: true
					headers: headers
					method: method
				)
				return
		else
			headers["Location"] ?= redirectURL
			status = 302 unless statuses.redirect[status]

	# Default the status to 200 if there is substance to the response.
	status = 200 if Number(status) is 404 and body?

	if statuses.empty[status] or not body?
		headers["Content-Type"] ?= undefined
		body = undefined

	else if isType.String(body)
		headers["Content-Type"] ?= "text/#{if /^\s*</.test(body) then "html" else "plain"}"

	else if isType.Object(body)
		headers["Content-Type"] ?= "application/json"
		body = JSON.stringify(body)

	else
		headers["Content-Type"] ?= "application/octet-stream"
		if body.length
			headers["Content-Length"] ?= body.length

		if isType.Stream(body)
			return body.pipe(originalRes)

	headers["Content-Length"] ?= byteLength(body)

	unless process.browser
		originalRes.writeHead(status, headers)
		originalRes.end(unless "HEAD" is method then body)
